#include "glwindow.h"
#include "math.h"
#include "mainwindow.h"

extern float ROLL,PITCH,YAW;
QTimer timer_update;
glwindow::glwindow(QWidget *parent) :
    QGLWidget(parent)
{
    roll=0;
    pitch=0;
    yaw=0;

    //timer_update = new QTimer(this);
    connect(&timer_update,SIGNAL(timeout()),this,SLOT(update_gl()));
    //timer_update.start(100);

}

void glwindow::initializeGL()
{
    glEnable( GL_DEPTH_TEST );
    glClearColor( 0.0, 0.0, 0.0, 0.0 );    
    glShadeModel( GL_SMOOTH );
    glClearDepth(1.0f);
    glDepthFunc(GL_LEQUAL);
   // gluLookAt(0,0,3,0,0,0,0,1,0);
    glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST );

    GLfloat light_dif[] = {1,1,1,1};
    GLfloat light_pos[] = {0.5,0.5,7,1};
    glEnable(GL_LIGHTING);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, light_dif);
    glLightfv(GL_LIGHT0, GL_POSITION, light_pos);
    glEnable(GL_LIGHT0);


}
void glwindow::resizeGL(int w, int h)
{
    int side = qMin(w, h);
    glViewport((w - side) / 2, (h - side) / 2, side, side);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
#ifdef QT_OPENGL_ES_1
    glOrthof(-0.5, +0.5, -0.5, +0.5, 4.0, 15.0);
#else
    glOrtho(-0.5, +0.5, -0.5, +0.5, 4.0, 15.0);
#endif
    glMatrixMode(GL_MODELVIEW);

}

void glwindow::paintGL()
{
    //renderText(20, 100, "Hello, My first OpenGL app.");
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    glTranslatef(0.0, 0.0, -10.0);
     // glTranslatef(0.0f, 0.0f,0.0f);	// Translate Into The Screen 7.0 Units
    glRotatef(roll,1.0f,0,0.0f);	// Rotate The cube around the Y axis
    glRotatef(pitch,0.0f,1.0f,0.0f);
    glRotatef(yaw,0.0f,0.0f,1.0f);

      glBegin(GL_QUADS);
      // Front Face
         glNormal3f( 0.0f, 0.0f, 1.0f);                  // Normal Pointing Towards Viewer
         glVertex3f(-0.3f, -0.01f,  0.3f);  // Point 1 (Front)
         glVertex3f( 0.3f, -0.01f,  0.3f);  // Point 2 (Front)
         glVertex3f( 0.3f,  0.01f,  0.3f);  // Point 3 (Front)
         glVertex3f(-0.3f,  0.01f,  0.3f);  // Point 4 (Front)
         // Back Face
         glNormal3f( 0.0f, 0.0f,-1.0f);                  // Normal Pointing Away From Viewer
         glVertex3f(-0.3f, -0.01f, -0.3f);  // Point 1 (Back)
         glVertex3f(-0.3f,  0.01f, -0.3f);  // Point 2 (Back)
         glVertex3f( 0.3f,  0.01f, -0.3f);  // Point 3 (Back)
         glVertex3f( 0.3f, -0.01f, -0.3f);  // Point 4 (Back)
         // Top Face
         glNormal3f( 0.0f, 1.0f, 0.0f);                  // Normal Pointing Up
         glVertex3f(-0.3f,  0.01f, -0.3f);  // Point 1 (Top)
         glVertex3f(-0.3f,  0.01f,  0.3f);  // Point 2 (Top)
         glVertex3f( 0.3f,  0.01f,  0.3f);  // Point 3 (Top)
         glVertex3f( 0.3f,  0.01f, -0.3f);  // Point 4 (Top)
         // Bottom Face
         glNormal3f( 0.0f,-1.0f, 0.0f);                  // Normal Pointing Down
         glVertex3f(-0.3f, -0.01f, -0.3f);  // Point 1 (Bottom)
         glVertex3f( 0.3f, -0.01f, -0.3f);  // Point 2 (Bottom)
         glVertex3f( 0.3f, -0.01f,  0.3f);  // Point 3 (Bottom)
         glVertex3f(-0.3f, -0.01f,  0.3f);  // Point 4 (Bottom)
         // Right face
         glNormal3f( 1.0f, 0.0f, 0.0f);                  // Normal Pointing Right
         glVertex3f( 0.3f, -0.01f, -0.3f);  // Point 1 (Right)
         glVertex3f( 0.3f,  0.01f, -0.3f);  // Point 2 (Right)
         glVertex3f( 0.3f,  0.01f,  0.3f);  // Point 3 (Right)
         glVertex3f( 0.3f, -0.01f,  0.3f);  // Point 4 (Right)
         // Left Face
         glNormal3f(-1.0f, 0.0f, 0.0f);                  // Normal Pointing Left
         glVertex3f(-0.3f, -0.01f, -0.3f);  // Point 1 (Left)
         glVertex3f(-0.3f, -0.01f,  0.3f);  // Point 2 (Left)
         glVertex3f(-0.3f,  0.01f,  0.3f);  // Point 3 (Left)
         glVertex3f(-0.3f,  0.01f, -0.3f);  // Point 4 (Left)
      glEnd();                                // Done Drawing Quads

       // roll+=30;
}

void glwindow::mousePressEvent(QMouseEvent *event)
{
    roll-=30;
    pitch -=10;
    updateGL();
}

void glwindow::update_gl()
{
    roll = ROLL;
    pitch = PITCH;
    yaw = YAW;
    updateGL();
}
