/*
 * worm.c
 *
 * Created: 2012/4/17 16:10:28
 *  Author: Andygongyb
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include "worm.h"

volatile uint8_t worm_dis_up = 0;
volatile uint8_t worm_dis_down = 0;
volatile uint8_t worm_state = 0;

void worm_init(void) {
	cli();
	PORTB &= ~_BV(PB1);
	DDRB |= _BV(PB1);
	SET_WORM_IN0;
	SET_WORM_IN1;
	WORM_DDR_IN0 |= _BV(WORM_IN0);
	WORM_DDR_IN1 |= _BV(WORM_IN1);
	sei();
}

void worm_set(int16_t speed) {
	if (speed > 1000) {
		speed = 1000;
	} else if (speed < -1000) {
		speed = -1000;
	}
	cli();
	if (speed > 0) {
		if (worm_dis_down == 0) {
			SET_WORM_IN0;
			CLR_WORM_IN1;
			OCR1A = speed;
			worm_state = WORM_DOWN;
		}
	} else if (worm_dis_up == 0) {
		SET_WORM_IN1;
		CLR_WORM_IN0;
		OCR1A = -speed;
		worm_state = WORM_UP;
	}
	sei();
}

void worm_break(void) {
	cli();
	SET_WORM_IN0;
	SET_WORM_IN1;
	OCR1A = 1000;
	worm_state = WORM_STOP;
	sei();
}